#!/usr/bin/perl
#
# yapw.cgi ( http://white.d51.net/yapw/yapw.cgi )
# $Id: yapw.cgi,v 1.159 2003/03/04 04:22:11 white Exp $

use EncodedTreeStore;
use strict;
use Algorithm::Diff qw(traverse_sequences);
no strict "refs";
umask 0;

#
# export-mode setting.
#
use vars qw(%mode %TemplateFILE
	    %exportlist %exportlist_r
	    $ExportDIR $ExportPageList);
if(@ARGV[0] =~ /^--export(.*?)/){
    shift;
    $mode{export} = 1;
    $ExportDIR = "EXPORT";
    $TemplateFILE{export} = "export.html";
}

# To Do:
#   * Auto embedding <base> element.
#
my(%cgi,%cookie,%TemplateCache,%cache,%Index,$commit_error);
my($root);
my($target);

END{
#    print STDERR "request over:$target\n";
}

use vars
    qw($Test %PATTERN
       $SIGN $ANONYSIGN
       $dataDIR $TemplateDIR
       $DEFAULT_INDEX
       $URLencoding $ENABLE_SUEXEC 
       $KeepBraket $NonExistMark $TIMESTAMPQUERY_DISABLE
       $HTTPDIR $SERVER $CGIpath $baseURL $SELFNAME
       $enableElems $enableEmptyElems
       $enableInlineElems $enableInlineBlockElems 
       $enableBlockElems $enableNonEmptyElems
       $mustcloseBlockElems $uncloseableBlockElems
       );

default_config();
require 'yapw.conf';
require 'jcode.pl';
commit_config();

# yapw.cgi is modal:
#  index, view, edit, set sign, add, write, atwrite and more

%cgi    = GETQuery();
%cookie = GETCookie();
if(defined $ENV{PATH_INFO}){
    $target = $ENV{PATH_INFO};
    $target =~s/^\///;
    $target = URLdecode($target);
    &jcode::convert(\$target,'euc');
    if($target =~ /^$/){
	undef $target;
    }
}

$root = new EncodedTreeStore($dataDIR);


if($ENV{REQUEST_METHOD} eq "HEAD"){
    print httpHead($target);
    exit(0);
}

if(defined $ExportDIR){
    $URLencoding = "export";
    $ExportPageList = $ARGV[0];
    mode_export();
    exit(0);
}

if(defined $cgi{exec_setsign}){
    mode_setsign($cgi{setsign});
}

if(defined $cgi{exec_add}){
    $target = $cgi{add};
    mode_edit($target);
}

if(defined $cgi{order} || defined $cgi{list}){
    mode_index($target);
    exit(0);
}

if(not defined $target){
    $target = $DEFAULT_INDEX
	if(length($DEFAULT_INDEX) > 0 && existcheck($DEFAULT_INDEX));
}

if(defined $target){
    mode_edit($target)    if defined $cgi{edit} && (length($target) > 0);
    mode_write($target)   if defined $cgi{write};
    mode_delete($target)  if defined $cgi{delete};
    mode_atwrite($target) if defined $cgi{atwrite};
    mode_view($target);
}

# anything else
mode_index($target);
exit(0);

# each mode functions 
#   / call from yapw.cgi

sub mode_setsign{
    my($sign) = @_;
    $sign = $cgi{setsign};
    $cookie{yapwsign} = $sign;
    print setCookie("yapwsign",$sign);
}

sub mode_index{
    my($target) = @_;
    print httpHead();

    my(@Index) = $root->__();
    @Index =
	map{ my $time =  $root->__($_)->__timestamp("SOURCE");
	     my $name = $_;
	     $name =~ s/\%/\\\%/g;
	     { time     => $time,
	       moddate  => time_str($time),
	       URI      => "$CGIpath/".URLencode($_),
	       name     => $name
	       }
	 } @Index;
    if($cgi{order} eq 'time'){
	@Index = sort { $b->{"time"} <=> $a->{"time"} } @Index;
    }else{
	@Index = sort { $a->{name} cmp $b->{name} } @Index;
    }
    my $content;
    foreach (@Index){
	$content .= 
	    sprintf(" *\\[%s]<a href='%s?time=%s'>%s</a>\n",
		    @{%$_}{qw(moddate URI time name)}  );
    }
    print makeView("",$content);
    exit(0);
}

sub mode_view{
    my($target) = @_;
    mode_redirect() if(! existcheck($target));
    print httpHead($target);
    print makeView($target);
    exit(0);
}

sub mode_edit{
    my($target) = @_;
    my($content);
    if(existcheck($target)){
	$content  = $root->__($target)->SOURCE();
	$content  = "" if (ref $content);
	$content  =~ s{\&}{\&amp;}g;
	$content  =~ s{\<}{\&lt;}g;
	$content  =~ s{\>}{\&gt;}g;
    }
    print httpHead($target);
    $content = resolveTemplate("edit",$content,$target,"edit");
    print resolveTemplate("base.html",$content,$target,"edit");
    exit(0);
}

sub mode_reedit{
    my($target) = @_;
    my $content  = $root->__($target)->SOURCE();
    $content = difftext($content,$cgi{text});
    $content  = "" if (ref $content);
    $content  =~ s{\&}{\&amp;}g;
    $content  =~ s{\<}{\&lt;}g;
    $content  =~ s{\>}{\&gt;}g;
    $content  = resolveTemplate("reedit",$content,$target,"edit");
    print httpHead($target);
    print resolveTemplate("base.html",$content,$target,"edit");
    exit(0);
}

sub difftext {
    my($old,$new) = @_;
    local(@main::old) = split(/\n/,$old);
    local(@main::new) = split(/\n/,$new);
    local($main::result,$main::del,$main::add);
    traverse_sequences
	(
	 \@main::old,\@main::new,
	 {
	     MATCH     => sub {$main::result .= $main::del.$main::add." ".$main::old[$_[0]]."\n";$main::del  = ""; $main::add = ""} ,
	     DISCARD_A => sub {$main::del .= "-".$main::old[$_[0]]."\n"},
	     DISCARD_B => sub {$main::add .= "+".$main::new[$_[1]]."\n"},
	 }
	 );
    return $main::result;
}

sub clear_indent{
    my($source) = @_;
    my(@source) = split(/\n/,$source);
    foreach(@source){
	if(/^[^-+ ]/ && !/^$/){
	    return $source;
	}
    }
    foreach(@source){
	s/^[-+ ]//;
    }
    return join("\n",@source);
}

sub mode_write{
    my($target) = @_;
    my($newsource) = $cgi{text};

    mode_reedit($target) if(conflictcheck($target));
    # create board if not exist.
    $root->__($target)->SOURCE("") if(!existcheck($target));
    my $oldsource = $root->__($target)->SOURCE();
    $oldsource  = "" if (ref $oldsource);
    $newsource = clear_indent($newsource);
    $newsource = staticAlias($newsource);
    if($oldsource ne $newsource){
	addRindex($target,$oldsource,$newsource);
	dropRindex($target,$oldsource,$newsource);
	$root->__($target)->SOURCE("$newsource");
    }
    print redirect($target);
    exit(0);
}

sub mode_redirect{
    my($target) = @_;
    print redirect($target);
    exit(0);
}

sub mode_atwrite{
    my($target)    = @_;
    my($label)     = $cgi{atwrite};
    mode_redirect() if(! existcheck($target));
    $cgi{addsign} = 1;$cgi{adddate} = 1;
    my $oldsource = $root->__($target)->SOURCE();
    my $newsource = atwrite_add($target,$oldsource,$label);
    $newsource = staticAlias($newsource);
    if($oldsource ne $newsource){
	addRindex($target,$oldsource,$newsource);
	dropRindex($target,$oldsource,$newsource);
	$root->__($target)->SOURCE($newsource."");
    }
    mode_redirect($target);
    exit(0);
}

sub mode_delete{
    my($target) = @_;
    my $source = $root->__($target)->SOURCE();
    $source  = "" if (ref $source);
    if(is_empty($source)){
	$root->__($target)->__(undef);
 	print redirect();
 	print httpHead();
 	exit(0);
    }else{
 	print redirect($target);
    }
}

sub mode_export{
    open(ExportPageList,$ExportPageList);
    while(<ExportPageList>){
	my($orig,$filename) = split(/[\s\t]+/,$_);
	$exportlist{$orig} = $filename;
	$exportlist_r{$filename} = $orig;
    }
    close(ExportPageList);
    my @Index = $root->__();
    foreach(@Index){
	my $output = $exportlist{$_} || $_;
	print "$_\n";
	my $result = makeExport($_);
	open(FILE,"> $ExportDIR/$output");
	print FILE $result;
	close(FILE);
    }
}

sub existcheck{
    my($target) = @_;
    umask 0;
    if(!ref($root->__($target))){
	print STDERR "  not exist:$target\n";
    }
    return 0 if(!$root->__($target)->{Type} == TreeStore::OBJECT());
    if(ref($root->__($target)->RINDEX())){
	my(@temp) = searchWord($target);
	$root->__($target)->RINDEX(@temp);
    }
    return 1;
}

sub conflictcheck{
    my($target) = @_;
    return 1 if($root->__($target)->__timestamp('SOURCE') != $cgi{timestamp});
    return 0;
}

sub redirect{
    my($target) = @_;
    my($filename,$timestamp);
    if($target eq ''){
	print "Location: $baseURL\n\n";
    }else{
	$filename  = URLencode($target);
	$timestamp = &TimestampQuery($target); 
	print "Location: $baseURL/$filename$timestamp\n\n";
    }
}

#
# Usual Fuctions for HTTP
#

sub setCookie{
    my($name,$value,@option) = @_;
    my($result,@day,@month);

    @day = ("Sun","Mon","Tue","Wed",
	    "Thu","Fri","Sat");
    @month = ("","Jan","Feb","Mar","Apr","May","Jun",
	      "Jul","Aug","Sep","Oct","Nov","Dec");
    my($sec,$min,$hour,$day,$month,$year,$wday,$yday,$dst)
        = gmtime(time + 365 * 24 * 60 * 60);
    $month++;$year += 1900;
    my $dateMes = 
        sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT"
                ,$day[$wday]
                ,$day,$month[$month],$year
                ,$hour,$min,$sec);
    $result .= "Set-cookie: $name=$value; path=$HTTPDIR; expires=$dateMes;\n";
    return $result;
}

sub URLencode{
#ARG = $plain | RETURNS = $encoded;
    return &{$URLencoding."encode"}(@_[0]);
}

sub URLdecode{
#ARG = $encoded | RETURNS = $plain;
    return &{$URLencoding."decode"}(@_[0]);
}

sub urlencode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    s/([^0-9a-zA-Z\-\_\.\!\~\*\(\)\/])/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub urldecode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

# SimpleBase64 : 
# URL base64 encoding function for Opera support.
# [Opera6.0 can not treat correctry URL-encoded URL includes non-ascii charctor.]
#  (It's more better divide then into other module.)
# make tables from $base64table.
my(%b64table);
sub base64_init{
    return if scalar(%b64table);
    local($_,@_);
    $b64table{pad} = [0,5,4,3,2,1];
    my $base64table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-';
    @_ = split(//,$base64table);
    my $i = 0;
    while(length($_ = shift(@_))){
	my($a,$b) = ($_,substr(unpack("B*",chr($i++)),2));
	die "SimpleBase64 : base table containts '$a' more than twice." if(defined $b64table{dec}{$a});
	$b64table{enc}{$b} = $a;
	$b64table{dec}{$a} = $b;
    }
    die "SimpleBase64 : base table length not enough $i" if($i != 64);
}
sub base64encode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    base64_init() if not defined %b64table;
    $_  = unpack("B*",$_);
    $_ .= "0" x $b64table{pad}->[length($_) % 6];
    $_  =~ s/(.{6})/$b64table{enc}{$1}/og;
    return $_;
}

sub base64decode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    my($pad,$length);
    base64_init() if not defined %b64table;
    $_  =~ s/(.)/$b64table{dec}{$1}/og;
    $pad    = length($_) % 8;
    $length = length($_) - $pad;
    $_  = substr($_,0,$length);
    $_  = pack("B*",$_);
    return $_;
}

sub exportencode{
    local($_) = @_;
    $_ = $exportlist{$_} || $_;
    return $_;
}

sub exportdecode{
    local($_) = @_;
    $_ = $exportlist_r{$_} || $_;
    return $_;
}

sub GETCookie{
#ARG = () | RETURNS = %cookie;
    my(%cookie,$line,$name,$value);
    foreach $line (split(/;\s*/,$ENV{HTTP_COOKIE})){
	($name,$value) = split(/=/,$line);
	$value = urldecode($value);
	$cookie{$name} = $value;
    }
    return %cookie;
}

sub GETQuery{
#ARG = () | RETURNS = %cgi_query;
    my(%cgi,$str);

    if($ENV{REQUEST_METHOD} eq "GET"){
	$str = $ENV{QUERY_STRING};	
    }else{	
	read(STDIN,$str,$ENV{'CONTENT_LENGTH'});
    }

    if($str =~ /=/){
	foreach my $i (split('&',$str)){
	    my($name,$value);
            if($i !~ /\=/){
                ($name,$value) = ($i,1);
            }else{
                ($name,$value) = split('=',$i);
            }
	    $value =~ tr/+/ /;
	    $value = urldecode($value);
	    &jcode::convert(*value,'euc');
	    $value =~ s/\015\012/\012/g;
	    $value =~ s/\015/\012/g;
	    $cgi{$name} = $value;
	}
    }else{
	$cgi{$str} = 1;
    }
    return %cgi;
    
}

sub joinpath{
    my($path);
    local($_);
    while(@_){
	$_ = shift(@_);
	last if($_ !~ /^\/*$/);
    }
    $path = $_;

    foreach(@_){
	next if($_ =~ /^\/*$/);
	$path .= "/" if(!/^\/$/);
	$path .= $_;
    }
    return $path;
}

sub httpHead{
    my($target) = @_;
    my $result .= "Content-type: text/html; charset=euc-jp\r\n";
    if($target ne '' && !$Test){
	my $time = Timestamp($target);
	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$stim) = gmtime($time);
	$wday = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$wday];
	$mon  = ("Jan","Feb","Mar","Apr","May","Jun"
		 ,"Jul","Aug","Sep","Oct","Nov","Dec")[$mon];
	$year += 1900;
	$result .=
	    sprintf("Last-Modified: %s, %02d %s %04d %02d:%02d:%02d GMT\r\n"
		    ,$wday,$day,$mon,$year,$hour,$min,$sec);
    }
    $result .= "\r\n";
    return $result;
}

sub getSign{
    $cookie{yapwsign} = $ANONYSIGN if($cookie{yapwsign} =~ /^\s*$/);
    return $cookie{yapwsign};
}

sub time_str{
    my($time) = @_;
    my(%time);
    @{%time}{qw(sec min hour mday mon
		year wday yday isdist)} = localtime($time);
    $time{year} += 1900;
    $time{mon}++;
    return sprintf("%04d/%02d/%02d %02d:%02d",
		   @{%time}{qw(year mon mday hour min)});
}

sub makeView{
    my($target,$content) = @_;
    my(%Index)   = $root->__();
    my(@Index)   = sort {length($a) <=> length($b);} keys %Index;

    $content||= $root->__($target)->SOURCE();
    $content  = undef if (ref $content);
    if(is_empty($content)){
	$content = &resolveTemplate("delete",'',$target);
    }else{
	$content = preDynamicAlias($content);
	$content = WikiLink($content,$target);
	$content = format_heading($content);
	$content = format_table($content);
	$content = format_list($content);
	$content = format_plain($content);
#	print STDERR $content;
	$content = postDynamicAlias($content,$target);
    }
    return resolveTemplate("base.html",$content,$target);
}


sub makeExport{
    my($target) = @_;
    my $Template = readTemplate("export");
    
    my $content  = $root->__($target)->SOURCE();
    $content  = undef if (ref $content);
    
    $content = preDynamicAlias($content);
    $content = elemFilter($content);
    $content = WikiLink($content,$target);
    $content = format_table($content);
    $content = format_list($content);
    $content = format_plain($content);
    $content = postDynamicAlias($content,$target);

    return resolveTemplate($TemplateFILE{export},$content,$target);
}

sub makeFindex{
#ARG = ($content) | RETURNS = (@FindexLIST);
    my($content) = @_;
    my(%result);

    $PATTERN{Index} = pattern_index();
    while($content =~ m{($PATTERN{Index})}og){
	$result{$1} = 1;
    }
    return sort keys %result;
}

sub compareFindex{
#ARG = (\@FindexLIST1,\@FindexLIST2) | RETURNS = @diffLIST;
# only returns entry defined in LIST1, but not defined in LIST2.
    my($NEWFindex,$OLDFindex) = @_;
    my($line,@diffLIST,%OLDFindex);
    local($_);
    foreach(@$OLDFindex){
	$OLDFindex{$_} = 1;
    }
    foreach $line(@$NEWFindex){
	push(@diffLIST,$line) if not defined $OLDFindex{$line};
    }
    return @diffLIST;
}

sub addRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex)   = makeFindex($oldsource);
    my(@newIndex)   = makeFindex($newsource);
    my(@targetLIST) = compareFindex(\@newIndex,\@oldIndex);
    foreach my $target (@targetLIST){
	my @rindex = $root->__($target)->RINDEX();
	$root->__($target)->RINDEX((@rindex,"$referer"));
    }
}

sub dropRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex)   = makeFindex($oldsource);
    my(@newIndex)   = makeFindex($newsource);
    my(@targetLIST) = compareFindex(\@oldIndex,\@newIndex);
    foreach my $target(@targetLIST){
	my(@content)= sort $root->__($target)->RINDEX();
	my $rindex;
	chomp(@content);
	foreach my $line(@content){
	    $rindex .= "$line\n" unless ($line eq $referer);
	}
	$root->__($target)->RINDEX($rindex);
    }
}

sub searchWord{
    my($key) = @_;
    my($qkey,@Index,@result,$content);
    local($_);
    @Index = $root->__();
    $qkey = quotemeta($key);
    
    $PATTERN{Index} = pattern_index();
    foreach my $target (@Index){
	$content = $root->__($target)->SOURCE();
	$content  = undef if (ref $content);
	foreach( ($content =~ m{($PATTERN{Index}|$qkey)}og) ){
	    if($_ eq $key){
		push(@result,$target);
		last;
	    }
	}
    }
    return @result;
}

sub Timestamp{
    my($target) = @_;
    return $root->__($target)->__timestamp("SOURCE");
}

sub TimestampQuery{
    my($target)   = @_;
    if($TIMESTAMPQUERY_DISABLE != 1){
       return '?time='.Timestamp($target);
    }else{
       return;
    }
}

sub pattern_index{
    local($_);
    my(%Index,@Index,$result);
    map{$Index{$_} = 1} ($root->__());
    @Index = sort {length($b) <=> length($a)} keys %Index;
    return join('|', map {$_ = quotemeta($_)} @Index);
}

sub WikiLink{
    local($_);
    my($content,$subject) = @_;
    my(@buffer,$result);

    $PATTERN{Index} = pattern_index();
    foreach(split(m{(  \\\\ | # \\ (escape backslash)
		       <a.*?>.*?</a> | # html's <a> element
		       <pre.*?>.*?</pre> | # html's <pre> element
		       \\?(?:$PATTERN{ATWRITE}|$PATTERN{TABLE}|\[.*?\]) | 
		       </?(?:$enableElems)(?:\s.*?)?>| # enable elements
		       $PATTERN{URL})
		    }sxo,$content)){
	if(/^\\\\/){
	    $_ = '\\';
	}elsif( m{^\\} || m{^<a.*?>.*?</a>}i || m{^$PATTERN{TABLE}}io ){ 
	}elsif(m{^</?(?:$enableElems)(?:\s.*?)?>}o){
	    if(m{^(<pre.*?>)(.*?)(</pre>)}s){
		my($pre,$epre) = ($1,$3);
		$_ = $2;
		my(@save) = ($KeepBraket,$NonExistMark);
		$KeepBraket   = 1;
		$NonExistMark = '';
		s{&}{&amp;}g;
		s{<}{&lt;}g;
		s{>}{&gt;}g;
		s{(^|[^\\])(\[(.*?)\]|$PATTERN{Index})}{"$1".mklink($2)}eog;
		$_ = $pre.$_.$epre;
		($KeepBraket,$NonExistMark) = @save;
	    }
	}elsif(m{^\[\@.*?\]}){
	    s/^\[\@(.*?(:(\[.*?\]|[^\[\]]*?)*)?)\]/&atwriteTool($1,$subject);/eg;
	}elsif(m{^https?://}){
	    $_ = "<a href='$_'>$_</a>";
	}else{
	    s{&}{&amp;}g;
	    s{<}{&lt;}g;
	    s{>}{&gt;}g;
	    s{($PATTERN{TEXT})(\[(.*?)\]|$PATTERN{Index}|$PATTERN{WikiName})}{$1.mklink($2)}eog;
	}
	$result .= $_;
    }
    return $result;
}

sub mklink{
    my($name) = @_;
    my($face,$body,$label);
    my($prev,$post);

    # parsing name
    if($name =~ /\[InterWiki=($PATTERN{URL}.*?)\]/){
	return "$name";
    }
    if($name =~ s/^\[(.*?)\]$/$1/){
	($prev,$post) = ('[' , ']') if $KeepBraket;
    }
    if($name =~ /.,./){
	($face,$body) = split(/,/,$name,2);
    }else{
	$face = $body = $name;
    }

    # linking.
    if($body =~ /^($PATTERN{Index})::(.*?)$/){
	my $InterWikiBase  = $1;
	my $InterWikiQuery = $2;
	my $source = $root->__($InterWikiBase)->SOURCE;
	if($source =~ /\[InterWiki::$InterWikiQuery=($PATTERN{URL}.*?)\]/){
	    my $InterWikiURL = $1;
	    return "<a href='".$InterWikiURL."'>$face</a>";
	}
	if($source =~ /\[InterWiki=($PATTERN{URL}.*?)\]/){
	    my $InterWikiURL = $1;
	    $InterWikiURL .= "\%q" if !($InterWikiURL =~ /\%q/);
	    $InterWikiURL =~ s/\%q/$InterWikiQuery/;
	    return "<a href='".$InterWikiURL."'>$face</a>";
	}
    }
    if($body =~ /^$PATTERN{URL}/){
	return "<a href='$body'>$face</a>";
    }
    $PATTERN{Index} = pattern_index();
    if($body =~ /^($PATTERN{Index})(\#.*?)?$/){
	my($name,$label) = ($1,$2);
	my $path = mklink_getpath($name,1)."$label";
	return "$prev<a href='$path'>$face</a>$post";
    }
    if($body =~ /^\#/){
	my $path = mklink_getpath($target,1).$body;
	return "$prev<a href='$path'>$face</a>$post";
    }
    if($NonExistMark){
	my $path = mklink_getpath($body,0);
	return "$prev$name$post<a href='$path?edit'>$NonExistMark</a>";
    }
    return "$prev$name$post";
}

sub mklink_getpath{
    my($name,$enable_timestamp) = @_;
    my $time = TimestampQuery($name) if $enable_timestamp;
    return "$SELFNAME/".URLencode($name).$time;
}

sub readTemplate{
#ARG = $templateName | RETURNS $Template;
#  %Template cashes Template files.
    my($label) = @_;
    my(%Template);
    if(exists $Template{$label}){
	return $Template{$label};
    }else{
	return ($TemplateCache{$label} ||= readfile("$TemplateDIR/$label"));
    }
}

sub readfile{
    my($path) = @_;
    my($result);
    open(FILE,"< $path");
    if(wantarray){
	my @result = <FILE>;
	close(FILE);
	return @result;
    }else{
	while(<FILE>){
	    $result .= $_;
	}
	close(FILE);
	return $result;
    }
}

sub staticAlias{
#ARG = ($source) | RETURNS = ($source);
    my($source) = @_;
    my($result);
    foreach(split(m{(\\$PATTERN{ATWRITE}|$PATTERN{ATWRITE})}io,$source)){
	if(!/^$PATTERN{ATWRITE}/io){
	    s/(^|[^\\])\%sign\%/"$1".&doSign();/emg;
	}
	$result .= $_;
    }
    return $result;
}

sub preDynamicAlias{
    my($source) = @_;
    $source =~ s/(^|[^\\])\%sign\%/"$1".&getSign();/eg;
    $source =~ s/(^|[^\\])\%YaPWsource\%/"$1".&showCGISource();/eg;

    return $source;
}

sub postDynamicAlias{
    my($source,$subject) = @_;

    $source =~ s/\\\[(.*?)\]/[$1]/g;

    return $source;
}

sub atwrite_add{
    my($target,$source,$label) = @_;

    mode_redirect($target) unless($source =~ /(?:^|[^\\])\[(\@+)$label(?::((\[.*?\]|.*?)+))?\]/s);
    my $before = $`;
    my $tool   = $&;
    my $after  = $';$';
    my($mode);
    if(length($1) >= 2){
	$mode = 'next';
    }else{
	$mode = 'previous';
    }
    my $format = $2 || '[]';
    my(@format) = split(/(\(.*?\)|<.*?>|\[.*?\]|\\\\|\n|\\n)/s,$format);
    my $addsource = '';
    my $verify    = '';
    my $count = 0;
    foreach(@format){
	if(/^\s*$/ || /^<.*?>$/){
	    $addsource .= $_;
	}elsif(/^\((.*?)\)$/){
	}elsif(/\[\%date\%\]/){
	    my($date_str) = getDate();
	    $addsource .= "($date_str)";
	    $verify    .= "($date_str)";
	}elsif(/^\[.*?\]/){
	    $count++;
	    $addsource .= $cgi{"at$count"};
	    $verify    .= $cgi{"at$count"};
	    next;
	}elsif(/^\\\\$/){
	    $addsource .= "\\";
	}elsif(/^\\n$/){
	    $addsource .= "\n";
	}else{
	    $addsource .= $_;
	}
    }
    if($count == 0){
	$count++;
	$addsource .= $cgi{"at$count"};
	$verify    .= $cgi{"at$count"};
    }
    mode_redirect($target) if($verify =~ /^\s*$/);
    if($mode eq 'previous'){
	$source = $before."\n".$addsource.$tool.$after;
    }else{
        $source = $before.$tool."\n".$addsource.$after;
    }
    return $source;
}

sub atwriteTool{
    my($label,$subject) = @_;
    my($form,$option,$count,$format,@format,$content,$path);
    $label  =~ /^\@*(.*?)(?::(.*))?$/s;
    $label  = $1;
    $format = $2 || '[]';

    @format = split(/(\(.*?\)|<.*?>|\[.*?\]|\\n|\n)/,$format);
    $path = $0."/".URLencode($subject);
    $form .= "<form action='$path' method='get'>";
    $count = 0;
    foreach(@format){
	if(/^\n$/){
	    $form .= "<br />\n";
	}elsif(/^\\n/){
	}elsif(/^\s*$/){
	}elsif(/\[\%date\%\]/){
	}elsif(/^\[(.*?)(?:[\/](.*?))?\]/){
	    $count++;
	    my $name = "at$count";
	    $option  = $1 || "size='50'";
	    $content = $2 || "";
	    if($option =~ /(cols|rows)/i){
		$form .= "<textarea name='$name' $option>$content</textarea>";
	    }else{
		$form .= "<input type='text' name='$name' $option value='$content' />";
	    }
	    next;
	}elsif(/^<.*?>$/){
	    $form .= $_;
	}elsif(/^\((.*?)\)$/){
	    $form .= $1;
	}else{
	    # anything else
	    $form .= $_;
	}
    }
    if($count == 0){
	$count++;
	$option = "size='50'";
	$form  .= "<input type='text' name='at$count' $option />";
    }
    $form .= "<input type='hidden' name='atwrite' value='$label'>";
    $form .= "<input type='submit' value='' />";
    $form .= "</form>";

    return $form;
}

sub resolveTemplate{
    my($TemplateName,$content,$subject,$mode) = @_;
    $content =~ s/\\\%/\\\\\%/mg if($mode eq "edit");
    local($_) = resolveTemplate_sub($TemplateName,$content,$subject,$mode);
    s{(^|[^\\])\%(.*?)\%}{(${$2})?"$1${$2}":"$1\%$2\%";}eg;
    s{(^|[^\\])\%findex\%}{$1.&showFindex($content,$subject);}se if($mode ne "edit");
    s/\\\%/\%/mg;
    return $_;
}

sub resolveTemplate_sub{
    my($TemplateName,$content,$subject,$mode) = @_;
    local($_) = readTemplate($TemplateName);

    s/(^|[^\\])\%navigation\%/$1.&resolveTemplate_sub("navigation",$content,$subject)/eg;
    s/(^|[^\\])\%sign\%/"$1".&getSign();/eg;
    s{(^|[^\\])\%content\%}{$1$content}g;
    s{(^|[^\\])\%baseURL\%}{$1$baseURL}g;
    s{(^|[^\\])\%cgiURL\%}{$1$CGIpath}g;
    s{(^|[^\\])\%pathinfo\%}{$1.&URLencode($subject)}eg;
    s{(^|[^\\])\%rindex\%}{$1.&showRindex($subject);}eg;
    s{(^|[^\\])\%timestamp\%}{$1.&Timestamp($subject)}eg;
    s{(^|[^\\])\%subject\%}{$1.$subject || "INDEX::"}eg;
    s{(^|[^\\])\%commit_error\%}{$1$commit_error}g;
    return $_;
}


sub doSign{
#ARG = () | RETURNS = ($date_and_sign);
    my($SIGN,$sign,$date);
    $sign             = getSign()  if(defined $cgi{addsign});
    if(defined $cgi{adddate}){
	my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	    =localtime(time);$mon++;$year += 1900;
	$date = sprintf("%04d/%02d/%02d %02d:%02d"
			,$year,$mon,$day,$hour,$min);
    }
    $SIGN = "<span class='signature'>--$date $sign<\/span>" if($sign || $date);
    return $SIGN;
}

sub getDate{
    my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	=localtime(time);$mon++;$year += 1900;
    return sprintf("%04d/%02d/%02d %02d:%02d",$year,$mon,$day,$hour,$min);
}

sub showCGISource{
#ARG = () | RETURNS = ($content_of_'this'_script);
    my(@source,$source);
    open(THIS,"$ENV{SCRIPT_FILENAME}");
    @source = <THIS>;
    close(THIS);
    $source = join('',@source);
    $source =~ s{<}{&lt;}g;
    $source =~ s{>}{&gt;}g;
    return "{perl version = $]}<hr /><pre>\n".$source."</pre><hr />\n";
}

sub showRindex{
# prepare Rindex
    my($target) = @_;
    my(@result);
    my @Rindex   = sort $root->__($target)->RINDEX();
    my $Rindex .= "\n";
    foreach my $line(@Rindex){
	next if($line =~ /^\s*$/);
	next if($line eq $target);
	my $filename  = URLencode($line);
	my $timestamp = Timestamp($line);
	push(@result,"<a href='$CGIpath/$filename?time=$timestamp'>$line</a>\n");
    }
    return join(" | ",@result);
}

sub showFindex{
    my($content,$subject) = @_;
    my(%Findex,@Findex);
    while($content =~ m{(<a href=.*?>(.*?)</a>)}ig){
	my($body,$name) = ($1,$2);
	next if($name eq $NonExistMark);
	next if($name =~ /^<img/);
	next if($name eq $subject);
	$Findex{$name} = $body;
    }
    map{push(@Findex,$Findex{$_})}(sort keys %Findex);
    return join(" | ",@Findex);
}

sub is_empty{
    my($text) = @_;
    if($text =~ /^\s*$/){
	return 1;
    }else{
	return 0;
    }
}

sub format_heading{
    my($text) = @_;
    my $result;
    
    foreach(split(m{(<pre>.*?</pre>)}s,$text)){
	if(/^<pre>/){
	    $result .= $_;
	}else{
	    my $lv;
	    $_ =~ s/^(\@+)(.*)$/
		$lv = length($1) + 1;sprintf("<h%d>%s<\/h%d>\n",$lv,$2,$lv)/mgex;
	    $result .= $_;
	}
    }
    return $result;
}

sub format_list{
    return eval_without_pre(\&format_list_core,@_);
}

sub eval_without_pre{
    my($func,$text) = @_;
    my $result;
    foreach(split(m{(<pre>.*?</pre>)}s,$text)){
	if(/^<pre>/){
	    $result .= $_;
	}else{
	    $result .= &$func($_);
	}
    }
    return $result;
}

sub format_list_unshift_level{
    my($indent,$level,$mode) = @_;
    my($result,$lv,$ty);
    while(@$level){
	$lv = $$level[0]->{level};
	$ty = $$level[0]->{type};
	last unless ($indent < $lv);
	$result .= ' ' x ($lv - 1) . "</li></$ty>\n" if($$mode);
	shift(@$level);
    }
    $mode = 0 if($lv eq '');
    return $result;
}

sub format_list_core{
    my($text) = @_;

    my($result);
    my(@level);
    my($mode) = 0;
    foreach(split(/\n/,$text)){
	/^((?:\s|)*)(.*?)$/;
	my $level     = length($1);
	my $indent    = ' ' x $level;
	my $content   = $2;
	my $list_mark = 0;
	do{$level++; 
	   $list_mark++;} if($content =~ s/^\*/<li>/);
	$list_mark++ if($content =~ s/^<li>\#/<li>/);
	
	my $current = $level[0];
	if($level < $current->{level}){
	    $result .= format_list_unshift_level($level,\@level,\$mode);
	    $result .= '</li>' if($mode && $list_mark);
	}elsif($level == $current->{level}){
	    $result .= '</li>' if($mode && $list_mark);
	}else{# if($indent > $current->{level});
	    if($list_mark){
		my $type = ('','ul','ol')[$list_mark];
		unshift(@level,{ level => $level,
				 type  => $type       });
		$result .= ' ' x ($level - 1) . "<$type>\n";
	    }
	}
	$result .= $indent.$content."\n";
	$mode |= $list_mark;
	$mode = 0 if($level[0] eq '');
    }
    $result .= format_list_unshift_level(0,\@level,\$mode);
    $result =~ s{\n(\s*)</li>}{</li>\n$1}g;
    return $result;
}

sub format_table{
    my($text) = @_;
    my $result;
    foreach(split(m{(<pre>.*?</pre>)}s,$text)){
	if(/^<pre>/){
	    $result .= $_;
	}else{
	    $result .= format_table_core($_);
	}
    }
    return $result;
}

sub format_table_core{
    my($text) = @_;
    my $is_table = 0;
    my($table,$result,$table_opt);
    foreach(split(m{\n}s,$text)){
	if(/^\|\|(.*?)\|\|/s){
	    $is_table = 1;
	    $table_opt = $1;
	    next;
	}elsif(s/^\|//s){
	    $is_table = 1;
	    $table .= "$_\n";
	    next;
	}else{
	    if($table){
		$is_table = 0;
		$result .=  format_table_maketable($table_opt,$table);
		$table = ""; $table_opt = "";
	    }
	    $result .= "$_\n";
	}
    }
    $result .= format_table_maketable($table_opt,$table) if($table);
    return $result;
}

sub format_table_maketable{
    my($table_opt,$text) = @_;
    my($result);
    $table_opt = " ".$table_opt if($table_opt);
    foreach(split("\n",$text)){
	my($line,@line);
	@line = split(/\|/,$_);
	while(@line){
	    $_ = shift(@line);
	    while(s/\\$//){
		$_ .=  "|". shift(@line);
	    }
	    my($colspan);
	    if(s/^(\s*)(~+)/$1/){
		$colspan = " colspan='".(length($2) + 1)."'";
	    }
	    $line .= "<td$colspan>$_</td>";
	}
	$result .= "<tr>$line</tr>\n" if($line);
    }
    $result = "<table$table_opt>\n$result</table>\n" if($result);
    return $result;
}

sub format_plain{
    return eval_without_pre(\&format_plain_core,@_);
}

sub format_plain_core{
    local($_) = @_;
    my($result,$elem,@paragraph,@temp,@elem);

    @paragraph = split(m{(</?(?:$enableNonEmptyElems)(?: .*?)?>)}soi,$_);
    
#    foreach(@paragraph){
#	print STDERR "$_\n";
#    }
    while(@paragraph){
	$_ = shift(@paragraph);
	if(m{<($enableBlockElems)( .*?)?>}oi){
	    my($elem) = $1;
	    push(@temp,$_);
	    while(@paragraph){
		$_ = shift(@paragraph);
		push(@temp,$_);
		last if(m{^<\/($elem)( .*?)?>}i);
	    }
	}else{
	    my $par;
	    while(@paragraph){
		if(m{</?($enableBlockElems)( .*?)?>}oi){
		    $par .= "\n\n$_";
		    $_ = "";
		    last;
		}
		$par .= $_;
		$_ = shift(@paragraph);
	    }
	    $par .= $_;
	    push(@temp,split(/(?:\s*?\n){2,}/s,$par));
	}
    } @paragraph = @temp;

    while(@paragraph){
	$_ = shift(@paragraph);
	if(m{</($enableBlockElems)>}oi){
	    my($elem) = $1;
	    while(@elem && $elem[0] ne $elem){
		shift(@elem);
	    }
	    shift(@elem);
	}elsif(m{^<($enableBlockElems)( .*?)?>}oi){
	    unshift(@elem,$1);
	}elsif(!@elem){
	    $_ = "<p>$_</p>\n";
	    s{(?:$PATTERN{CR}){2,}}{</p>\n<p>}smg;
	}
	s{\n}{<br />\n}mg;
	s{<(/?)($enableBlockElems|$enableInlineBlockElems)>(\n*)<br />}{<$1$2>$3}sog;
	s{<br />(\n*)\s*<(/?)($enableBlockElems|$enableInlineBlockElems)>}{$1<$2$3>}sog;
	s/^\s*<br \/>$//mg;
	s{</tr><br />}{</tr>}mg;
	s{<p></p>}{\n}g;
	$result .= $_;
    }
    return $result;
}

sub commit_config{
    $enableBlockElems    = "$uncloseableBlockElems|$mustcloseBlockElems";
    $enableNonEmptyElems = "$enableInlineElems|$enableBlockElems";
    $enableElems         = "$enableNonEmptyElems|$enableEmptyElems";
}

sub default_config{
## default configurations
    $Test = 1;

# localhost configuration
    my $baseDIR      = ($ENV{SCRIPT_FILENAME} =~ /^(.*)\/.*?$/)[0];
    $dataDIR      = "./DATA";
    $TemplateDIR  = "./Template";
    $SELFNAME     = ($ENV{SCRIPT_FILENAME} =~ /^.*\/(.*?)$/)[0];

# http configuration
    $HTTPDIR      = ($ENV{SCRIPT_NAME} =~ /^(.*)\/.*?$/)[0];
    $CGIpath      = $ENV{SCRIPT_NAME};
    $baseURL    ||= "http://$ENV{SERVER_NAME}$ENV{SCRIPT_NAME}";
    $ENABLE_SUEXEC  = 'no';

    $URLencoding  = 'url'; # url / base64
  
# Displaying configuration
    $KeepBraket = 0;
    $NonExistMark = '?';

# html-elements enable list
    $enableInlineElems =
	"a|em|strong|cite|dfn|code|samp|kbd|var|abbr|acronym|".
	    "sub|sup|pre|address|tt|i|b|s|big|small|span|del|ins";
    $uncloseableBlockElems  = "blockquote|p|pre|dl|ul|ol|h2|h3|h4";
    $mustcloseBlockElems    = "dt|dd|li|div";
    $enableInlineBlockElems = "del|ins";
    $enableBlockElems = "$uncloseableBlockElems|$mustcloseBlockElems|$enableInlineBlockElems";
    $enableEmptyElems = "img|br|hr";
    $enableNonEmptyElems = "$enableInlineElems|$enableBlockElems";
    $enableElems      = "$enableNonEmptyElems|$enableEmptyElems";
    
# user-sign&auth
    $ANONYSIGN = "somebody";
    $SIGN      = "";

# matching patterns
    $PATTERN{URL}    = '(?:(?:|https?|ftp)://|mailto:)[\w;/?:@&=\+\$\.,\-!~\*\%\'\(\)\#]+';
    $PATTERN{ATWRITE}= '\[\@(?:\[.*?\]|[^\[\]]*?)+\]';
    $PATTERN{TABLE}  = '\[\#(?:\[.*?\]|[^\[\]]*?)+\]';
    $PATTERN{WikiName}= '(?:[A-Z]+[a-z]+){2,}';
    $PATTERN{CR}     = '\r\n|\n|\r';
    $PATTERN{TEXT}   = '(?:^|\s|\G)(?:[\x00-\x7f]|[\x80-\xff][\x80-\xff])*?'
}

